﻿Option Strict On
Imports Coding4Fun.Kinect.KinectService.Common
Imports Coding4Fun.Kinect.KinectService.PhoneClient
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim _skeletonClient As SkeletonClient
    Dim _colorClient As ColorClient

    Private Sub okButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles okButton.Click
        Dim myIPAddress As String = addressTextBox.Text

        If myIPAddress = String.Empty Then
            MessageBox.Show("Addressを入力してください。")
            Exit Sub
        Else
            _skeletonClient = New SkeletonClient()
            _colorClient = New ColorClient()

            If Not _colorClient.IsConnected Then
                _colorClient.Connect(myIPAddress, 4530)
            Else
                _colorClient.Disconnect()
            End If

            If Not _skeletonClient.IsConnected Then
                _skeletonClient.Connect(myIPAddress, 4532)
            Else
                _skeletonClient.Disconnect()
            End If
            AddHandler _colorClient.ColorFrameReady, AddressOf client_ColorFrameReady
            AddHandler _skeletonClient.SkeletonFrameReady, AddressOf client_SkeletonFrameReady
        End If

    End Sub

    Private Sub client_ColorFrameReady(ByVal sender As Object, ByVal e As ColorFrameReadyEventArgs)
        If e.ColorFrame.BitmapImage IsNot Nothing Then
            Image1.Source = e.ColorFrame.BitmapImage
        End If
    End Sub

    Private Sub client_SkeletonFrameReady(ByVal sender As Object, ByVal e As SkeletonFrameReadyEventArgs)
        Dim mySkeleton As Skeleton = (From s In e.SkeletonFrame.Skeletons Where s.TrackingState = SkeletonTrackingState.Tracked Select s).FirstOrDefault()

        If mySkeleton Is Nothing Then
            Return
        End If

        SetEllipsePosition(headEllipse, mySkeleton.Joints(CInt(JointType.Head)))
        SetEllipsePosition(leftEllipse, mySkeleton.Joints(CInt(JointType.HandLeft)))
        SetEllipsePosition(rightEllipse, mySkeleton.Joints(CInt(JointType.HandRight)))

        SetEllipsePosition(hipCenterEllipse, mySkeleton.Joints(CInt(JointType.HipCenter)))

        SetEllipsePosition(ElbowLeftEllipse, mySkeleton.Joints(CInt(JointType.ElbowLeft)))
        SetEllipsePosition(ElbowRightEllipse, mySkeleton.Joints(CInt(JointType.ElbowRight)))

        SetEllipsePosition(shoulderLeftEllipse, mySkeleton.Joints(CInt(JointType.ShoulderLeft)))
        SetEllipsePosition(shoulderRightEllipse, mySkeleton.Joints(CInt(JointType.ShoulderRight)))

        SetEllipsePosition(HipLeftEllipse, mySkeleton.Joints(CInt(JointType.HipLeft)))
        SetEllipsePosition(HipRightEllipse, mySkeleton.Joints(CInt(JointType.HipRight)))
    End Sub

    Private Sub SetEllipsePosition(myEllipse As Ellipse, myJoint As Joint)
        Canvas.SetLeft(myEllipse, (448 * myJoint.Position.X) + 224)
        Canvas.SetTop(myEllipse, (336 * -myJoint.Position.Y) + 168)
    End Sub
End Class

